<?php 
/********** Get value custom menu *************/
add_filter( 'wp_setup_nav_menu_item', 'webhosty_add_custom_nav_fields' );
function webhosty_add_custom_nav_fields( $menu_item ) {
	$menu_item->icon = get_post_meta( $menu_item->ID, '_menu_item_icon', true );
	$menu_item->hide = get_post_meta( $menu_item->ID, '_menu_item_hide', true );
	$menu_item->style_webhosty = get_post_meta( $menu_item->ID, '_menu_item_style_webhosty', true );
	return $menu_item;
}
/********** Save value custom menu *************/
add_action( 'wp_update_nav_menu_item', 'webhosty_update_custom_nav_fields', 10, 3 );

function webhosty_update_custom_nav_fields( $menu_id, $menu_item_db_id, $args ) {
    $check = array( 'icon', 'hide', 'style_webhosty');

    foreach ( $check as $key ) {
		
        if (!isset($_POST['menu-item-'.$key][$menu_item_db_id])){
            if (!isset($args['menu-item-'.$key]))
                $value = "";
            else
                $value = $args['menu-item-'.$key];
        } else {
            $value = $_POST['menu-item-'.$key][$menu_item_db_id];
        } 
        update_post_meta( $menu_item_db_id, '_menu_item_'.$key, $value );
    }
}
/********** Edit custom menu *************/
add_filter( 'wp_edit_nav_menu_walker', 'webhosty_edit_walker', 10, 2 );

function webhosty_edit_walker($walker,$menu_id) {
    return 'Walker_Nav_Menu_Edit_Custom_Webhosty';
}
class Walker_Nav_Menu_Edit_Custom_Webhosty extends Walker_Nav_Menu  {
	
    function start_lvl( &$output, $depth = 0, $args = array() ) {
    }

    function end_lvl( &$output, $depth = 0, $args = array() ) {
    }
	
	function start_el( &$output, $item, $depth = 0, $args = array(), $id = 0 ) {
        global $_wp_nav_menu_max_depth;

        $_wp_nav_menu_max_depth = $depth > $_wp_nav_menu_max_depth ? $depth : $_wp_nav_menu_max_depth;

        $indent = ( $depth ) ? str_repeat( "\t", $depth ) : '';

        $item_id = esc_attr( $item->ID );
        $removed_args = array(
            'action',
            'customlink-tab',
            'edit-menu-item',
            'menu-item',
            'page-tab',
            '_wpnonce',
        );
        ob_start();
        $original_title = '';
        if ( 'taxonomy' == $item->type ) {
            $original_title = get_term_field( 'name', $item->object_id, $item->object, 'raw' );
            if ( is_wp_error( $original_title ) )
                $original_title = false;
        } elseif ( 'post_type' == $item->type ) {
            $original_object = get_post( $item->object_id );
            $original_title = $original_object->post_title;
        }

        $classes = array(
            'menu-item menu-item-depth-' . $depth,
            'menu-item-' . esc_attr( $item->object ),
            'menu-item-edit-' . ( ( isset( $_GET['edit-menu-item'] ) && $item_id == $_GET['edit-menu-item'] ) ? 'active' : 'inactive'),
        );

        $title = $item->title;

        if ( ! empty( $item->_invalid ) ) {
            $classes[] = 'menu-item-invalid';
            /* translators: %s: title of menu item which is invalid */
            $title = sprintf( '%s (Invalid)', $item->title );
        } elseif ( isset( $item->post_status ) && 'draft' == $item->post_status ) {
            $classes[] = 'pending';
            /* translators: %s: title of menu item in draft status */
            $title = sprintf( '%s (Pending)', $item->title );
        }
        $title = empty( $item->label ) ? $title : $item->label;
		?>
		<li id="menu-item-<?php echo esc_attr($item_id); ?>" class="<?php echo implode(' ', $classes ); ?>">
			<dl class="menu-item-bar">
			<dt class="menu-item-handle">
				<span class="item-title"><?php echo esc_html( $title ); ?></span>
				<span class="item-controls">
					<span class="item-type"><?php echo esc_html( $item->type_label ); ?></span>
					<span class="item-order hide-if-js">
						<a href="<?php
							echo wp_nonce_url(
								add_query_arg(
									array(
										'action' => 'move-up-menu-item',
										'menu-item' => $item_id,
									),
									remove_query_arg($removed_args, admin_url( 'nav-menus.php' ) )
								),
								'move-menu_item'
							);
							?>" class="item-move-up"><abbr title="Move up">&#8593;</abbr></a>
						|
						<a href="<?php
							echo wp_nonce_url(
								add_query_arg(
									array(
										'action' => 'move-down-menu-item',
										'menu-item' => $item_id,
									),
									remove_query_arg($removed_args, admin_url( 'nav-menus.php' ) )
								),
								'move-menu_item'
							);
							?>" class="item-move-down"><abbr title="Move down">&#8595;</abbr></a>
					</span>
					<a class="item-edit" id="edit-<?php echo esc_attr($item_id); ?>" title="Edit Menu Item" href="<?php
						echo ( isset( $_GET['edit-menu-item'] ) && $item_id == $_GET['edit-menu-item'] )
							? admin_url( 'nav-menus.php' )
							: add_query_arg( 'edit-menu-item', $item_id,
								remove_query_arg( $removed_args, admin_url( 'nav-menus.php#menu-item-settings-' . $item_id ) ) );
						?>"><?php echo __('Edit Menu Item','webhosty'); ?></a>
				</span>
			</dt>
			</dl>
			<div class="menu-item-settings" id="menu-item-settings-<?php echo esc_attr($item_id); ?>">
				<?php if( 'custom' == $item->type ) : ?>
					<p class="description description-wide">
						<label for="edit-menu-item-url-<?php echo esc_attr($item_id); ?>">
						<?php echo __('URL','webhosty'); ?><br />
						<input type="text" id="edit-menu-item-url-<?php echo esc_attr($item_id); ?>" class="widefat code edit-menu-item-url"
						name="menu-item-url[<?php echo esc_attr($item_id); ?>]"
						data-name="menu-item-url[<?php echo esc_attr($item_id); ?>]"
						value="<?php echo esc_url( $item->url ); ?>" />
						</label>
					</p>
				<?php endif; ?>
				<p class="description description-wide">
					<label for="edit-menu-item-title-<?php echo esc_attr($item_id); ?>">
						<?php echo __('Navigation Label','webhosty'); ?><br />
						<input type="text" id="edit-menu-item-title-<?php echo esc_attr($item_id); ?>" class="widefat edit-menu-item-title"
							   name="menu-item-title[<?php echo esc_attr($item_id); ?>]"
							   data-name="menu-item-title[<?php echo esc_attr($item_id); ?>]"
							   value="<?php echo esc_attr( $item->title ); ?>" />
					</label>
				</p>
				<p class="description">
					<label for="edit-menu-item-target-<?php echo esc_attr($item_id); ?>">
						<input type="checkbox" id="edit-menu-item-target-<?php echo esc_attr($item_id); ?>" value="_blank"
							   name="menu-item-target[<?php echo esc_attr($item_id); ?>]"
							   data-name="menu-item-target[<?php echo esc_attr($item_id); ?>]"
							<?php checked( $item->target, '_blank' ); ?> />
						<?php echo __('Open link in a new window/tab','webhosty'); ?>
					</label>
				</p>
				<p class="description description-wide">
					<label for="edit-menu-item-attr-title-<?php echo esc_attr($item_id); ?>">
						<?php echo __('Title Attribute','webhosty'); ?><br />
						<input type="text" id="edit-menu-item-attr-title-<?php echo esc_attr($item_id); ?>" class="widefat edit-menu-item-attr-title"
							   name="menu-item-attr-title[<?php echo esc_attr($item_id); ?>]"
							   data-name="menu-item-attr-title[<?php echo esc_attr($item_id); ?>]"
							   value="<?php echo esc_attr( $item->post_excerpt ); ?>" />
					</label>
				</p>
				<p class="description description-thin">
					<label for="edit-menu-item-classes-<?php echo esc_attr($item_id); ?>">
						<?php echo 'CSS Classes (optional)'; ?><br />
						<input type="text" id="edit-menu-item-classes-<?php echo esc_attr($item_id); ?>" class="widefat code edit-menu-item-classes"
							   name="menu-item-classes[<?php echo esc_attr($item_id); ?>]"
							   data-name="menu-item-classes[<?php echo esc_attr($item_id); ?>]"
							   value="<?php echo esc_attr( implode(' ', $item->classes ) ); ?>" />
					</label>
				</p>
				<p class="description description-thin">
					<label for="edit-menu-item-xfn-<?php echo esc_attr($item_id); ?>">
						<?php echo __('Link Relationship (XFN)','webhosty'); ?><br />
						<input type="text" id="edit-menu-item-xfn-<?php echo esc_attr($item_id); ?>" class="widefat code edit-menu-item-xfn"
							   name="menu-item-xfn[<?php echo esc_attr($item_id); ?>]"
							   data-name="menu-item-xfn[<?php echo esc_attr($item_id); ?>]"
							   value="<?php echo esc_attr( $item->xfn ); ?>" />
					</label>
				</p>
				
				<?php if ($depth == 0){ ?>
				<p class="description">
					<label for="edit-menu-item-hide-<?php echo esc_attr($item_id); ?>">
						<?php echo "Don't show a link ( Show as a heading)"; ?>
						<select id="edit-menu-item-type-menu-<?php echo esc_attr($item_id); ?>"
								name="menu-item-style_webhosty[<?php echo esc_attr($item_id); ?>]"
							data-name="menu-item-style_webhosty[<?php echo esc_attr($item_id); ?>]"
							style="width:100%;"
							>
							<option value="style one" <?php if(esc_attr($item->style_webhosty) == "style one"){echo 'selected="selected"';} ?>><?php echo 'style one'; ?></option>
							<option value="style two" <?php if(esc_attr($item->style_webhosty) == "style two"){echo 'selected="selected"';} ?>><?php echo 'style two'; ?></option>
						</select>
					</label>
				</p>
				<?php } ?>
				<?php if ($depth == 1){ ?>
				<p class="description">
					<label for="edit-menu-item-hide-<?php echo esc_attr($item_id); ?>">
						<input type="checkbox" id="edit-menu-item-hide-<?php echo esc_attr($item_id); ?>" class="code edit-menu-item-custom" value="hide"
							   name="menu-item-hide[<?php echo esc_attr($item_id); ?>]"
							   data-name="menu-item-hide[<?php echo esc_attr($item_id); ?>]"
							<?php checked( $item->hide, 'hide' ); ?> />
						<?php echo __("Don't show a link ( Show as a heading)"); ?>
					</label>
				</p> 
				<?php } ?>
				<?php if ($depth != 0){ ?>
				<p class="description description-wide">
					<label for="edit-menu-item-icon-<?php echo esc_attr($item_id); ?>">
						<?php echo 'Font Awesome Icon Class'; ?><br />
						<input type="text" id="edit-menu-item-icon-<?php echo esc_attr($item_id); ?>" class="widefat code edit-menu-item-icon"
								name="menu-item-icon[<?php echo esc_attr($item_id); ?>]"
							   data-name="menu-item-icon[<?php echo esc_attr($item_id); ?>]"
							   value="<?php echo esc_attr( $item->icon ); ?>" />
						<span><?php echo __('Input font awesome icon or icon class. You can see <a target="_blank" href="http://fortawesome.github.io/Font-Awesome/icons/">Font Awesome Icons in here</a>.', 'webhosty') ?></span>
					</label>
				</p>
				<?php } ?>
				<div class="menu-item-actions description-wide submitbox">
					<?php if( 'custom' != $item->type && $original_title !== false ) : ?>
					<p class="link-to-original">
						<?php printf( 'Original: %s', '<a href="' . esc_attr( $item->url ) . '">' . esc_html( $original_title ) . '</a>' ); ?>
					</p>
					<?php endif; ?>
					<a class="item-delete submitdelete deletion" id="delete-<?php echo esc_attr($item_id); ?>" href="<?php
						echo wp_nonce_url(
							add_query_arg(
								array(
									'action' => 'delete-menu-item',
									'menu-item' => $item_id,
								),
								remove_query_arg($removed_args, admin_url( 'nav-menus.php' ) )
							),
							'delete-menu_item_' . $item_id
						); ?>"><?php echo 'Remove'; ?></a> <span class="meta-sep"> | </span> <a class="item-cancel submitcancel" id="cancel-<?php echo esc_attr($item_id); ?>" href="<?php echo esc_url( add_query_arg( array('edit-menu-item' => $item_id, 'cancel' => time()), remove_query_arg( $removed_args, admin_url( 'nav-menus.php' ) ) ) );
					?>#menu-item-settings-<?php echo esc_attr($item_id); ?>"><?php echo __('Cancel','webhosty'); ?></a>
				</div>
				<input class="menu-item-data-db-id" type="hidden" name="menu-item-db-id[<?php echo esc_attr($item_id); ?>]" value="<?php echo esc_attr($item_id); ?>" />
				<input class="menu-item-data-object-id" type="hidden" name="menu-item-object-id[<?php echo esc_attr($item_id); ?>]" value="<?php echo esc_attr( $item->object_id ); ?>" />
				<input class="menu-item-data-object" type="hidden" name="menu-item-object[<?php echo esc_attr($item_id); ?>]" value="<?php echo esc_attr( $item->object ); ?>" />
				<input class="menu-item-data-parent-id" type="hidden" name="menu-item-parent-id[<?php echo esc_attr($item_id); ?>]" value="<?php echo esc_attr( $item->menu_item_parent ); ?>" />
				<input class="menu-item-data-position" type="hidden" name="menu-item-position[<?php echo esc_attr($item_id); ?>]" value="<?php echo esc_attr( $item->menu_order ); ?>" />
				<input class="menu-item-data-type" type="hidden" name="menu-item-type[<?php echo esc_attr($item_id); ?>]" value="<?php echo esc_attr( $item->type ); ?>" />
			</div><!-- .menu-item-settings-->
			<ul class="menu-item-transport"></ul>
		</li>
		<?php
		$output .= ob_get_clean();
	}
}
if (!class_exists('webhosty_menu_navwalker')) {
    class webhosty_menu_navwalker extends Walker_Nav_Menu {
		
		var $column = '';
		var $mainheading = '';
		var $mega_ul = false;
		var $wbool = 0;
		function display_element( $element, &$children_elements, $max_depth, $depth=0, $args, &$output )
		{
			$this->column = $element->style_webhosty;
			$id_field = $this->db_fields['id'];
			if ( is_object( $args[0] ) ) {
				$args[0]->has_children = ! empty( $children_elements[$element->$id_field] );
			}
			return parent::display_element( $element, $children_elements, $max_depth, $depth, $args, $output );
		}
	
		function start_lvl( &$output, $depth = 0, $args = array() ) {
			$indent = str_repeat("\t", $depth);
			$out_div = '';
			if($this->column == 'style one' || $this->mega_ul || $depth >= 1){
				$output .= "\n$indent$out_div<ul>\n";			
				$this->wbool++;
			}else{
				$output .= "\n$indent$out_div<div>\n";			
			}
		}   
		
		function end_lvl( &$output, $depth = 0, $args = array() ) {
			if($this->wbool || $this->mega_ul){
				$output .= "</ul>";	
				$this->mega_ul = false;
				$this->wbool--; 
			}else{
				$output .= "</div>";	
			}
		}
		
		function start_el( &$output, $item, $depth = 0, $args = array(), $id = 0 ) {
			
			$indent = ( $depth ) ? str_repeat( "\t", $depth ) : '';
			$classes = empty( $item->classes ) ? array() : (array) $item->classes;
			$classes[] = 'menu-item-' . $item->ID;
			
			// depth dependent classes
			if ( $item->current || $item->current_item_ancestor || $item->current_item_parent )
				$classes[] = 'current-menu-item';
			
			$class_names = join( ' ', apply_filters( 'nav_menu_css_class', array_filter( $classes ), $item, $args, $depth ) );
			$class_names = $class_names ? ' class="' . esc_attr( $class_names ) . '"' : '';
		 
			
			$id = apply_filters( 'nav_menu_item_id', 'menu-item-'. $item->ID, $item, $args, $depth );
			$id = $id ? ' id="' . esc_attr( $id ) . '"' : '';
			
			if(isset($item->hide) && $item->hide == 'hide'){
				$output .= $indent . '<div>';
				$item_output = '<h2>'.esc_attr($item->title).'</h2>';
				$this->mega_ul = true;
			}
			else{
				$output .= $indent . '<li' . $id . $class_names .'>';
				
				$atts = array();
				$atts['title']  = ! empty( $item->attr_title ) ? $item->attr_title : '';
				$atts['target'] = ! empty( $item->target )     ? $item->target     : '';
				$atts['rel']    = ! empty( $item->xfn )        ? $item->xfn        : '';
				$atts['href']   = ! empty( $item->url )        ? $item->url        : '';
				
				$atts = apply_filters( 'nav_menu_link_attributes', $atts, $item, $args, $depth );
			 
				$attributes = '';
				foreach ( $atts as $attr => $value ) {
					if ( ! empty( $value ) ) {
						$value = ( 'href' === $attr ) ? esc_url( $value ) : esc_attr( $value );
						$attributes .= ' ' . $attr . '="' . $value . '"';
					}
				}
				$cls = ''; 
				if(!empty($item->icon)){
					$cls = 'w_menu_icon';
				}
				$item_output = $args->before;
				$item_output .= '<a'. $attributes .' class="'.esc_attr($cls).'">';
				$item_output .= $args->link_before . apply_filters( 'the_title', $item->title, $item->ID ) . $args->link_after;
				$item_output .= ($item->icon ? '<i class="fa fa-' . str_replace('fa-', '', $item->icon) . '"></i>' : '');
				$item_output .= '</a>';
				$item_output .= $args->after;
						
			}
			
			$output .= apply_filters( 'walker_nav_menu_start_el', $item_output, $item, $depth, $args );
		}
		
		function end_el( &$output, $item, $depth = 0, $args = array() ) {
			if($item->hide == 'hide'){
				$output .= '</div>';
			}else{
				$output .= '</li>';
			}
		}  
	}
}
?>